﻿Imports System.Reflection
Imports System.Threading
Imports ionDESK.Abstracts
Imports System.Text

Public Class Form1


    Private WithEvents LinxClient1 As New ionDESK.Linx.Client.LinxClient

    Shared Function ConvertFromOptionSymbologyTo_OCCFormat(e As String) As String

        Dim q As New Quote

        Quote.ConvertFromOptionSymbology(q, e)

        Return String.Format(".{0}{1}", q.optionUnderlier.ToUpper.PadRight(6), q.symbol.Remove(0, q.optionUnderlier.Length))




    End Function


    Private Sub Button3_Click(sender As Object, e As EventArgs)
        ConvertFromOptionSymbologyTo_OCCFormat("SPY160715C00213000")
    End Sub
    Private Sub Button7_Click(sender As Object, e As EventArgs) Handles Button7.Click
        LinxClient1.Monitor.UnSubscribeToEvents()

    End Sub
    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click


        ' Subscribe to events
        Dim response = LinxClient1.Monitor.SubscribeToEvents

        If response.Data = True Then
            MessageBox.Show("Events will be published to the client form")
        Else
            MessageBox.Show("Events didn't connect")
            If response.Errors.Any Then MessageBox.Show(response.Errors.FirstOrDefault.Problem)
        End If


    End Sub

    Private Sub LinxClient1_OnOrderCancelledEvent(e As ionDESK.Response.GenericResponse(Of OrderList)) Handles LinxClient1.OnOrderCancelledEvent

        Dim o As OrderList = e.Data

        MessageBox.Show("On Order Cancelled Event " & o.orderId)

    End Sub

    Private Sub LinxClient1_OnOrderPlacedEvent(e As ionDESK.Response.GenericResponse(Of OrderList)) Handles LinxClient1.OnOrderPlacedEvent


        Dim o As OrderList = e.Data

        MessageBox.Show("On Order Placed Event " & o.orderId)

    End Sub


    Private Sub LinxClient1_OnOrderRejectedEvent(e As ionDESK.Response.GenericResponse(Of OrderList)) Handles LinxClient1.OnOrderRejectedEvent
        Dim o As OrderList = e.Data
        MessageBox.Show("On Order Rejected Event " & o.orderId)
    End Sub


    Private Sub btnPlaceBuyOrder_Click(sender As Object, e As EventArgs) Handles btnPlaceBuyOrder.Click

        Dim o As New ionDESK.Abstracts.Order

        With o
            .priceType = ionDESK.Abstracts.OrderBase.EnumPriceType.LIMIT
            .limitPrice = 1
            .symbol = "FB"

            'Set order action to BUY
            .orderAction = ionDESK.Abstracts.OrderBase.enumOrderAction.BUY

            .orderType = ionDESK.Abstracts.OrderBase.EnumOrderType.EQ
            .orderTerm = ionDESK.Abstracts.OrderBase.EnumOrderTerm.GOOD_FOR_DAY
            .orderedQuantity = 1
            .accountID = ionDESK.Abstracts.Order.GetPracticeAccountIDShared ' Account Number
        End With

        ' Capture time before we place order
        Dim t As Date = Now

        Dim r = LinxClient1.Order.PlaceOrder(o)





        If r.HasErrors Then
            MessageBox.Show(r.Errors.First.Problem)

        Else
            Dim OrderInfo As ionDESK.Abstracts.Order = r.Data

            ' When the order is placed live or practice... it will contain reference ID in the ClientOrderID  
            ' From there the proper way to get the proper order is via the ClientOrderID ...Then you'll be able 
            ' to acquire the proper related order


            Dim OrderID = OrderInfo.clientOrderId

            MessageBox.Show(OrderID)

            ' We can call the order list looking for that ID



            ' Get all orders in orders list by account
            Dim AllOrders As List(Of ionDESK.Abstracts.OrderList) = LinxClient1.Order.GetOrderList(o.accountID)

            ' Get a single order from filtered orders list by clientOrderId  
            Dim SingleOrderReturned As OrderList = Nothing

            Do Until SingleOrderReturned IsNot Nothing

                AllOrders = LinxClient1.Order.GetOrderList(o.accountID)

                'Use time to get the last order  by status and is entering
                SingleOrderReturned = AllOrders _
                    .Where(Function(OrderinList) OrderinList.orderStatus = OrderBase.EnumOrderStatus.OPEN _
                               AndAlso OrderinList.IsEnteringTrade).LastOrDefault()
                Thread.Sleep(500)
            Loop






            If SingleOrderReturned IsNot Nothing Then
                MessageBox.Show("Order Status " & SingleOrderReturned.orderStatus.ToString)

            Else
                MessageBox.Show("There is no executed orders at this time.")
            End If














            'From here you can get any info about the order
        End If

    End Sub


    Private Sub btnPlaceSellOrder_Click(sender As Object, e As EventArgs) Handles btnPlaceSellOrder.Click
        Dim o As New ionDESK.Abstracts.Order

        With o
            .priceType = ionDESK.Abstracts.OrderBase.EnumPriceType.MARKET
            .limitPrice = 70
            .symbol = "FB"
            'Set order action to SELL. If a matching open order exists the sell will be processed. Otherwise the order will be rejected.
            .orderAction = ionDESK.Abstracts.OrderBase.enumOrderAction.SELL

            .orderType = ionDESK.Abstracts.OrderBase.EnumOrderType.EQ
            .orderTerm = ionDESK.Abstracts.OrderBase.EnumOrderTerm.GOOD_FOR_DAY
            .orderedQuantity = 1000
            .accountID = ionDESK.Abstracts.Order.GetPracticeAccountIDShared
        End With

        Dim r = LinxClient1.Order.PlaceOrder(o)

        If r.HasErrors Then
            MessageBox.Show(r.Errors.First.Problem)
        Else
            Dim OrderInfo As ionDESK.Abstracts.Order = r.Data
            'From here you can get any info about the order

        End If
    End Sub

    Private Sub btnGetQuote_Click(sender As Object, e As EventArgs) Handles btnGetQuote.Click

        Dim r = LinxClient1.Data.Quote("AAPL")

        If r.IsDataReady Then
            MessageBox.Show(String.Format("Name : {0} Bid : {1} Ask : {2} Price : {3}",
                                          r.companyName & vbCrLf, r.bid & vbCrLf, r.ask & vbCrLf, r.lastTrade))
        Else
            MessageBox.Show("Try again the quote info is not ready yet.")
        End If

    End Sub



    Private Sub btnSystemInfo_Click(sender As Object, e As EventArgs) Handles btnSystemInfo.Click


        CheckConnection()

    End Sub

    Private Sub btnGetAccounts_Click(sender As Object, e As EventArgs) Handles btnGetAccounts.Click

        Dim l = LinxClient1.Account.GetAccounts
        Dim b As New StringBuilder

        If l.Count = 0 Then
            MessageBox.Show("No Accounts exist")


        Else

            '     l.ForEach(Sub(a) b.Append(" Acct# " & a.accountID & " " & a.accountDesc & vbCrLf))
            '   MessageBox.Show(b.ToString)


            ' Load Account list combobox
            cmbAccountsList.Items.Clear()
            cmbAccountsList.DisplayMember = "DisplayName"
            cmbAccountsList.ValueMember = "accountID"

            For Each aa In l
                cmbAccountsList.Items.Add(aa)
            Next

            cmbAccountsList.SelectedIndex = 0

        End If


    End Sub

    Private Sub btnQueryAccountPositions_Click(sender As Object, e As EventArgs) Handles btnQueryAccountPositions.Click
        Dim l As New List(Of String)

        l.Add("Previously Captured Order ID #1")
        l.Add("Previously Captured Order ID #2")
        l.Add("Previously Captured Order ID #etc")

        'Note this API call will return a account position for each order id. 
        'If the account position exist, an account position object will be returned
        'otherwise the collection item will be null
        Dim p = LinxClient1.Order.GetAccountPositionsPerAccountID("00000000")

        If p.Count = 0 Then

            MessageBox.Show("No account positions found.")
        Else
            ' DO task here that make use of Account Positions

            For Each acc In p
                If Not acc Is Nothing Then
                    'DO task
                End If
            Next
        End If


    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        lbl_linxTitle.Text = String.Format("Linx API : Client Examples : {0}Version {1}", vbCrLf, Assembly.GetExecutingAssembly.GetName.Version)
    End Sub

    Private Sub btnGetHistoricalData_Click(sender As Object, e As EventArgs) Handles btnGetHistoricalData.Click


        'Note : historical data may not be available upon first request...Use Object.IsDataready to check for availability
        Dim DataToday = LinxClient1.Data.OHLC("AAPL", ionDESK.Data.HistQuoteDataBaseRequest.EnumBarInterval._3_Minute, Now)

        Dim D As Date = CDate(Now.AddDays(-1).ToShortDateString & " 9:30:00 AM")

        Dim DataYesterday = LinxClient1.Data.OHLC("AAPL", ionDESK.Data.HistQuoteDataBaseRequest.EnumBarInterval._3_Minute, D)


        'Dim r = LinxClient1.Data.OHLC("AAPL", ionDESK.Data.HistQuoteDataBaseRequest.EnumBarInterval._3_Minute, Now)

        If DataToday.IsDataReady AndAlso DataYesterday.IsDataReady AndAlso DataToday.Data.Count > 17 Then



            MessageBox.Show(String.Format("Number of Bars {0}", DataToday.Data.Count))

            For Each c In DataToday.Data
                ' Show a message for each candle in data chain
                If Not MessageBox.Show(GetCandleData(c), "", MessageBoxButtons.OKCancel) = Windows.Forms.DialogResult.OK Then

                    Exit For

                End If

            Next
            ' Get last 4 candles
            Dim ListofCandles4 As List(Of ionDESK.Data.HistoricalDataPoint) = DataToday.Data.Skip(DataToday.Data.Count - (4)).Take(4).ToList

            ' Get last 17 candles
            Dim ListofCandles17 As List(Of ionDESK.Data.HistoricalDataPoint) = DataToday.Data.Skip(DataToday.Data.Count - (17)).Take(17).ToList

            Dim StartDate As DateTime = CDate(Now.ToShortDateString & " 2:00:00 PM")
            Dim Enddate As DateTime = CDate(Now.ToShortDateString & " 3:00:00 PM")

            'get candles between dates
            Dim GetCandlesBetween2and3PM = DataToday.Data.Where(Function(x)

                                                                    Return (x.Date.TimeOfDay >= StartDate.TimeOfDay) AndAlso (x.Date.TimeOfDay <= Enddate.TimeOfDay)

                                                                End Function).ToList


            For Each c In ListofCandles4

            Next


        Else
            MessageBox.Show("There is no historical data at this time.")
        End If

    End Sub

    Private Function GetCandleData(p As ionDESK.Data.HistoricalDataPoint) As String
        Return String.Format("Candle 1 info Open {0} High {1} Low {2} Close {3} Date {4}" & vbCrLf,
                                             p.Open & vbCrLf, p.High & vbCrLf, p.Low & vbCrLf, p.Close & vbCrLf, p.Date.ToString & vbCrLf)
    End Function

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        Dim o As New ionDESK.Abstracts.Order
        Dim Positions = LinxClient1.Order.GetAccountPositionsPerAccountID(o.GetPracticeAccountID)

        If Positions IsNot Nothing AndAlso Positions.Count > 0 Then
            MessageBox.Show(Positions.Count)
        Else
            MessageBox.Show("There are no positions at this time.")
        End If
    End Sub

    Private Sub btnCancelORders_Click(sender As Object, e As EventArgs) Handles btnCancelORders.Click


        'Note : GetPracticeAccountIDShared return the first practice account. Now we have multiple practice accounts that can be used
        'Dim ListOfOrders = LinxClient1.Order.GetOrderList(ionDESK.Abstracts.Order.GetPracticeAccountIDShared)

        'Get the List
        Dim ListOfOrders = LinxClient1.Order.GetOrderList("00000000")

        'Loop List
        For Each l In ListOfOrders
            'Ask if can Cancel

            If l.CanCancel Then
                'Cancel Order
                LinxClient1.Order.CancelOrderInOrderList(l)
            End If
        Next

        ListOfOrders = Nothing


    End Sub

    Private Sub btnCancelAll_Click(sender As Object, e As EventArgs) Handles btnCancelAll.Click
        'Cancel Order

        Dim AcctNumber As String = ionDESK.Abstracts.Order.GetPracticeAccountIDShared


        LinxClient1.Order.CancelAllOrders(AcctNumber)


    End Sub

    Private _Order As ionDESK.Abstracts.Order



    Private Sub btnGetOrderlistExecuted_Click(sender As Object, e As EventArgs) Handles btnGetOrderlistExecuted.Click
        Dim AcctNumber As String = ionDESK.Abstracts.Order.GetPracticeAccountIDShared

        ' Get all orders in orders list
        Dim l As List(Of ionDESK.Abstracts.OrderList) = LinxClient1.Order.GetOrderList(AcctNumber)

        ' Get all orders from filtered orders list by AccountID , then get executed orders 
        Dim Fl As List(Of ionDESK.Abstracts.OrderList) = l.Where(Function(o) o.executedPrice > 0).ToList




        If Fl.Count > 0 Then
            MessageBox.Show(String.Format("{0} Total executed orders.", Fl.Count))
        Else
            MessageBox.Show("There are no executed orders at this time.")
        End If


    End Sub

    Private Sub btnGetCanceledOrders_Click(sender As Object, e As EventArgs) Handles btnGetCanceledOrders.Click

        Dim AcctNumber As String = ionDESK.Abstracts.Order.GetPracticeAccountIDShared

        Dim l As List(Of ionDESK.Abstracts.OrderList) = LinxClient1.Order.GetOrderList(AcctNumber)

        Dim Fl As List(Of ionDESK.Abstracts.OrderList) = l.Where(Function(o) o.IsCancelled).ToList

        If Fl.Count > 0 Then
            MessageBox.Show(String.Format("{0} Total cancelled orders", Fl.Count))
        Else
            MessageBox.Show("There is no cancelled orders at this time.")
        End If


    End Sub


    Private Sub btnLoadFromFile_Click(sender As Object, e As EventArgs) Handles btnLoadFromFile.Click
        GetOrderFromTemplate()


    End Sub

    'Private Function GetOrderFromTemplate2() As ionDESK.Abstracts.Order
    '    Return GetOrderFromTemplate("MHP01_TemplateOrder_PUT")
    'End Function

    ''' <summary>
    ''' This function illustrates how to load an order from a template. This is powerful because it allows for some 
    ''' advanced legs to remain as a part of the solution while 
    ''' allowing the flexibility of modifying the order leg.
    ''' </summary>
    Private Function GetOrderFromTemplate() As ionDESK.Abstracts.Order
        Return GetOrderFromTemplate("templateOrder.ids_Order")
    End Function
    ''' <summary>
    ''' This function illustrates how to load an order from a template. This is powerful because it allows for some 
    ''' advanced legs to remain as a part of the solution while 
    ''' allowing the flexibility of modifying the order leg.
    ''' </summary>
    Private Function GetOrderFromTemplate(Name As String) As ionDESK.Abstracts.Order



        _Order = New ionDESK.Abstracts.Order

        'D = Location ( Path )  for the running app ( EXE )
        Dim d = New IO.FileInfo(Reflection.Assembly.GetExecutingAssembly.Location)

        Try
            'load template from directory
            Dim path As String = d.Directory.FullName & "\" & Name
            If IO.File.Exists(path) Then

                If _Order.LoadFromFile(path) Then
                    MessageBox.Show("Template Loaded!")
                Else
                    MessageBox.Show("Template Not loaded!")
                End If


            Else
                MessageBox.Show("Path To template doesn't exist")
            End If


        Catch ex As Exception
            MessageBox.Show("Problem loading template file : 1013 " & ex.Message)
        End Try





        Return _Order

    End Function
    Private Sub Button8_Click(sender As Object, e As EventArgs) Handles Button8.Click


        Dim RootOrder = GetOrderFromTemplate(InputBox("Enter Template Name", "Template", "templateOrder.ids_Order"))

        If RootOrder Is Nothing Then
            MessageBox.Show("Template order is not available.")
            Exit Sub
        End If

        RootOrder.priceType = ionDESK.Abstracts.OrderBase.EnumPriceType.MARKET
        RootOrder.accountID = Order.GetPracticeAccountIDShared
        RootOrder.BrokerID = 0
        RootOrder.routingDestination = OrderBase.EnumRoutingDestination.AUTO


        RootOrder.SyncOrderSymbol()
        RootOrder.ResetAllIDs()
        RootOrder.SyncOrderedQuantity()


        RootOrder.AlignAccountInfo(RootOrder.accountID, RootOrder.BrokerID)



        Dim r = LinxClient1.Order.PlaceOrder(RootOrder)



    End Sub

    Private Sub Button3_Click_1(sender As Object, e As EventArgs) Handles Button3.Click
        'Get template order as our 'Root Order'
        Dim RootOrder = GetOrderFromTemplate()

        If RootOrder Is Nothing Then
            MessageBox.Show("Template order is not available.")
            Exit Sub
        End If

        ' Now we have a root order

        ' This example assumes you have a template order with 3 legs ( Entry, Target, Stop)

        Dim EntryOrder = RootOrder.Orders.Where(Function(x) x.OrderPointType = OrderBase.EnumOrderPointType.Entry).FirstOrDefault
        Dim TargetOrder = RootOrder.Orders.Where(Function(x) x.OrderPointType = OrderBase.EnumOrderPointType.Target).FirstOrDefault
        Dim StopOrder = RootOrder.Orders.Where(Function(x) x.OrderPointType = OrderBase.EnumOrderPointType.Stop).FirstOrDefault

        If EntryOrder IsNot Nothing Then
            ' Change to limit
            EntryOrder.priceType = OrderBase.EnumPriceType.LIMIT
            EntryOrder.limitPrice = 59.6

        End If


        If StopOrder IsNot Nothing Then

            ' Change the special types offset values -  i.e. 'STOP_AT_ASK,STOP_AT_BID, etc.'
            StopOrder.VariablePriceOffset = -0.04


        End If



        'now that you've adjusted your order (s)

        ' You can simply send the entire order to ionDESK for processing


    End Sub


    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click

        LinxClient1.Data.RemoveAllChartsFromDirectoryCache()

    End Sub

    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles Button5.Click

        'Connect to Local Computer
        LinxClient1.Configuration.Host = "localhost:9000" ' local instance of ionDESK should have matching host and port configuration


        ' Check it
        CheckConnection()


    End Sub
    Private RemoteComputerHostInfo As String = "Hostname:Port"

    Private Sub Button6_Click(sender As Object, e As EventArgs) Handles Button6.Click

        'Connect to remote Computer
        ' remote instance of ionDESK should have matching host and port configuration
        ' Ensure that HttpGetEnabled is selected on instance of ionDESK
        'Sample idcwebserver:9000
        RemoteComputerHostInfo = InputBox("Enter Host name on remote computer", "ionDESK Linx API", RemoteComputerHostInfo)
        LinxClient1.Configuration.Host = RemoteComputerHostInfo



        ' Check it
        CheckConnection()


        ' Not connecting 

        '''try these links
        ''' https://rohitguptablog.wordpress.com/2011/06/16/configuring-wcf-service-with-nettcpbinding/
        ''' 
        'netstat -a -n -p TCP ' List all computer listening 


        'Go to "Programs and Features" (usually in control panel)
        'Go to "Turn Windows features on or off"
        '(assuming VS2012) Go to ".NET Framework 4.5 Advanced Services"->"WCF Services"
        'Enable "TCP Activation"
    End Sub



    Private Sub CheckConnection()





        Dim ConnectionInfo As String = "Not Connected to : " & LinxClient1.Configuration.Host

        Try
            Dim r = LinxClient1.SystemInfo.Ping

            lblConnectionInfo.Visible = True
            If r.HasErrors Then
                MessageBox.Show(r.Errors.First.Problem)
                ConnectionInfo = "Not Connected"
            Else
                MessageBox.Show(String.Format("ionDESK is connected {0}Host : {1}", vbCrLf & vbCrLf, LinxClient1.Configuration.Host))

                ConnectionInfo = "Connected to ionDESK at : " & LinxClient1.Configuration.Host




            End If
        Catch ex As Exception
            MessageBox.Show("ionDESK is not connected!")

        End Try

        lblConnectionInfo.Text = ConnectionInfo
    End Sub

    Private Sub Button10_Click(sender As Object, e As EventArgs) Handles Button10.Click

        'Dim f = LinxClient1.SystemInfo.GetAddinDllPaths

        'For Each AddinPath In f.Data
        '    Try
        '        Reflection.Assembly.LoadFrom(AddinPath)
        '    Catch ex As Exception
        '    End Try
        'Next

        ' New single call eliminates the need for this code.
        Dim r = LinxClient1.LoadAddinsIntoMemory()

        If r.Errors.Any Then
            '  enumerate errors
        End If
    End Sub
End Class
